# SPDX-FileCopyrightText: Copyright © 2023 Idiap Research Institute <contact@idiap.ch>
#
# SPDX-License-Identifier: GPL-3.0-or-later

from torch.utils.data.dataset import ConcatDataset


def _maker(protocol):
    if protocol == "default":
        from ..indian import default as indian
        from ..montgomery import default as mc
        from ..shenzhen import default as ch
    elif protocol == "rgb":
        from ..indian import rgb as indian
        from ..montgomery import rgb as mc
        from ..shenzhen import rgb as ch
    elif protocol == "fold_0":
        from ..indian import fold_0 as indian
        from ..montgomery import fold_0 as mc
        from ..shenzhen import fold_0 as ch
    elif protocol == "fold_1":
        from ..indian import fold_1 as indian
        from ..montgomery import fold_1 as mc
        from ..shenzhen import fold_1 as ch
    elif protocol == "fold_2":
        from ..indian import fold_2 as indian
        from ..montgomery import fold_2 as mc
        from ..shenzhen import fold_2 as ch
    elif protocol == "fold_3":
        from ..indian import fold_3 as indian
        from ..montgomery import fold_3 as mc
        from ..shenzhen import fold_3 as ch
    elif protocol == "fold_4":
        from ..indian import fold_4 as indian
        from ..montgomery import fold_4 as mc
        from ..shenzhen import fold_4 as ch
    elif protocol == "fold_5":
        from ..indian import fold_5 as indian
        from ..montgomery import fold_5 as mc
        from ..shenzhen import fold_5 as ch
    elif protocol == "fold_6":
        from ..indian import fold_6 as indian
        from ..montgomery import fold_6 as mc
        from ..shenzhen import fold_6 as ch
    elif protocol == "fold_7":
        from ..indian import fold_7 as indian
        from ..montgomery import fold_7 as mc
        from ..shenzhen import fold_7 as ch
    elif protocol == "fold_8":
        from ..indian import fold_8 as indian
        from ..montgomery import fold_8 as mc
        from ..shenzhen import fold_8 as ch
    elif protocol == "fold_9":
        from ..indian import fold_9 as indian
        from ..montgomery import fold_9 as mc
        from ..shenzhen import fold_9 as ch
    elif protocol == "fold_0_rgb":
        from ..indian import fold_0_rgb as indian
        from ..montgomery import fold_0_rgb as mc
        from ..shenzhen import fold_0_rgb as ch
    elif protocol == "fold_1_rgb":
        from ..indian import fold_1_rgb as indian
        from ..montgomery import fold_1_rgb as mc
        from ..shenzhen import fold_1_rgb as ch
    elif protocol == "fold_2_rgb":
        from ..indian import fold_2_rgb as indian
        from ..montgomery import fold_2_rgb as mc
        from ..shenzhen import fold_2_rgb as ch
    elif protocol == "fold_3_rgb":
        from ..indian import fold_3_rgb as indian
        from ..montgomery import fold_3_rgb as mc
        from ..shenzhen import fold_3_rgb as ch
    elif protocol == "fold_4_rgb":
        from ..indian import fold_4_rgb as indian
        from ..montgomery import fold_4_rgb as mc
        from ..shenzhen import fold_4_rgb as ch
    elif protocol == "fold_5_rgb":
        from ..indian import fold_5_rgb as indian
        from ..montgomery import fold_5_rgb as mc
        from ..shenzhen import fold_5_rgb as ch
    elif protocol == "fold_6_rgb":
        from ..indian import fold_6_rgb as indian
        from ..montgomery import fold_6_rgb as mc
        from ..shenzhen import fold_6_rgb as ch
    elif protocol == "fold_7_rgb":
        from ..indian import fold_7_rgb as indian
        from ..montgomery import fold_7_rgb as mc
        from ..shenzhen import fold_7_rgb as ch
    elif protocol == "fold_8_rgb":
        from ..indian import fold_8_rgb as indian
        from ..montgomery import fold_8_rgb as mc
        from ..shenzhen import fold_8_rgb as ch
    elif protocol == "fold_9_rgb":
        from ..indian import fold_9_rgb as indian
        from ..montgomery import fold_9_rgb as mc
        from ..shenzhen import fold_9_rgb as ch

    mc = mc.dataset
    ch = ch.dataset
    indian = indian.dataset

    dataset = {}
    dataset["__train__"] = ConcatDataset(
        [mc["__train__"], ch["__train__"], indian["__train__"]]
    )
    dataset["train"] = ConcatDataset(
        [mc["train"], ch["train"], indian["train"]]
    )
    dataset["__valid__"] = ConcatDataset(
        [mc["__valid__"], ch["__valid__"], indian["__valid__"]]
    )
    dataset["validation"] = ConcatDataset(
        [mc["validation"], ch["validation"], indian["validation"]]
    )
    dataset["test"] = ConcatDataset([mc["test"], ch["test"], indian["test"]])

    return dataset
