# SPDX-FileCopyrightText: Copyright © 2023 Idiap Research Institute <contact@idiap.ch>
#
# SPDX-License-Identifier: GPL-3.0-or-later


def _maker(protocol, resize_size=512, cc_size=512, RGB=True):
    import torchvision.transforms as transforms

    from ....data.padchest import dataset as raw
    from ....data.transforms import SingleAutoLevel16to8
    from .. import make_dataset as mk

    post_transforms = []
    if not RGB:
        post_transforms = [transforms.Lambda(lambda x: x.convert("L"))]

    return mk(
        [raw.subsets(protocol)],
        [
            SingleAutoLevel16to8(),
            transforms.Resize(resize_size),
            transforms.CenterCrop(cc_size),
        ],
        [transforms.RandomHorizontalFlip()],
        post_transforms,
    )
